// wprincipal.cpp: implementation of the WPrincipal class.
//
//////////////////////////////////////////////////////////////////////

#include "wprincipal.h"

FXDEFMAP(WPrincipal) WPrincipalMap[]={
  FXMAPFUNC(SEL_COMMAND,WPrincipal::ID_NEW,WPrincipal::onNewClick),
  FXMAPFUNC(SEL_COMMAND,WPrincipal::ID_CANCEL,WPrincipal::onCancelClick),
  FXMAPFUNC(SEL_COMMAND,WPrincipal::ID_UPDATE,WPrincipal::onUpdateClick),
  FXMAPFUNC(SEL_COMMAND,WPrincipal::ID_DELETE,WPrincipal::onDeleteClick)
};

FXIMPLEMENT(WPrincipal,FXMainWindow, WPrincipalMap, ARRAYNUMBER(WPrincipalMap));

WPrincipal::WPrincipal(FXApp *a):FXMainWindow(a, "PyM", NULL, NULL, DECOR_ALL, 10, 10, 640, 480)
{
	FXVerticalFrame *vf = new FXVerticalFrame(this, LAYOUT_FILL_X|LAYOUT_FILL_Y);
	
	db_contacts = new DBInterface(vf, LAYOUT_FILL_X);
	db_contacts->connect("localhost", "root", "", "PhoneBook");
	db_contacts->setTable("Contacts");

	db_phones = new DBInterface(vf, LAYOUT_FILL_X|LAYOUT_BOTTOM);
	db_phones->relateWith(db_contacts, "contact_id", "id");
	db_phones->connect("localhost", "root", "", "PhoneBook");
	db_phones->setTable("Phones");


	FXHorizontalFrame *h1 = new FXHorizontalFrame(vf, LAYOUT_FILL_X);
	new FXLabel(h1, "Name : ");
	d[0] = new DBTextField(db_contacts, h1, 15, NULL, 0, LAYOUT_FILL_X|TEXTFIELD_NORMAL);
	d[0]->setFieldName("Name");

	FXHorizontalFrame *h2 = new FXHorizontalFrame(vf, LAYOUT_FILL_X);
	new FXLabel(h2, "E-Mail : ");
	d[1] = new DBTextField(db_contacts, h2, 15, NULL, 0, LAYOUT_FILL_X|TEXTFIELD_NORMAL);
	d[1]->setFieldName("EMail");

	FXHorizontalFrame *h3 = new FXHorizontalFrame(vf, LAYOUT_FILL_X);
	new FXLabel(h3, "Nick Name : ");
	d[2] = new DBTextField(db_contacts, h3, 15, NULL, 0, LAYOUT_FILL_X|TEXTFIELD_NORMAL);
	d[2]->setFieldName("NickName");

	FXHorizontalFrame *h4 = new FXHorizontalFrame(vf, LAYOUT_FILL_X|LAYOUT_BOTTOM);
	new FXLabel(h4, "Phones : ");
	d[3] = new DBTextField(db_phones, h4, 15, NULL, 0, LAYOUT_FILL_X|TEXTFIELD_NORMAL|LAYOUT_BOTTOM);
	d[3]->setFieldName("number");

	FXHorizontalFrame *hf = new FXHorizontalFrame(vf, LAYOUT_FILL_X);
	btnNew = new FXButton(hf, "New", NULL, this, ID_NEW, LAYOUT_FILL_X|BUTTON_NORMAL);
	btnCancel = new FXButton(hf, "Cancel", NULL, this, ID_CANCEL, LAYOUT_FILL_X|BUTTON_NORMAL);
	btnUpdate = new FXButton(hf, "Update", NULL, this, ID_UPDATE, LAYOUT_FILL_X|BUTTON_NORMAL);
	btnDelete = new FXButton(hf, "Delete", NULL, this, ID_DELETE, LAYOUT_FILL_X|BUTTON_NORMAL);
}

WPrincipal::~WPrincipal()
{
}

void WPrincipal::create()
{
	FXTopWindow::create();
	btnCancel->disable();
	for(int i=0; i<4; i++) d[i]->disable();
	show();
}

long WPrincipal::onNewClick(FXObject *obj, FXSelector sel, void *ptr)
{
	if (btnNew->getText() == "New") {
		for(int i=0; i<3; i++) d[i]->enable();
		db_contacts->newEntry();
		btnNew->setText("Save");
		btnUpdate->disable();
		btnCancel->enable();
	} else {
		db_contacts->saveEntry();
		btnNew->setText("New");
		btnUpdate->enable();
		btnCancel->disable();
		for(int i=0; i<3; i++) d[i]->disable();
	}
	return 1;
}

long WPrincipal::onCancelClick(FXObject *obj, FXSelector sel, void *ptr)
{
	db_contacts->cancelEntry();
	btnNew->setText("New");
	btnUpdate->setText("Update");
	btnNew->enable();
	btnUpdate->enable();
	btnCancel->disable();
	for(int i=0; i<4; i++) d[i]->disable();
	return 1;
}

long WPrincipal::onUpdateClick(FXObject *obj, FXSelector sel, void *ptr)
{
	if (btnUpdate->getText() == "Update") {
		for(int i=0; i<3; i++) d[i]->enable();
		db_contacts->updateEntry();
		btnUpdate->setText("Save");
		btnNew->disable();
		btnCancel->enable();
	} else {
		db_contacts->saveEntry();
		btnUpdate->setText("Update");
		btnNew->enable();
		btnCancel->disable();
		for(int i=0; i<3; i++) d[i]->disable();
	}
	return 1;
}

long WPrincipal::onDeleteClick(FXObject *obj, FXSelector sel, void *ptr)
{
	db_contacts->deleteCurrentEntry();
	return 1;
}
